import { A3, A4, A5, A6, LARGE_MARGINS, LEGAL, LETTER, NO_MARGINS, NORMAL_MARGINS, TABLOID, } from './page';
const noop = () => undefined;
export const landscape = (fields) => (fields.landscape = true);
export const portrait = (fields) => (fields.landscape = undefined);
export function paperSize(paper) {
    if (!paper)
        return noop;
    return (fields) => {
        if (Array.isArray(paper)) {
            ;
            [fields.paperWidth, fields.paperHeight] = paper;
        }
        else {
            ;
            ({ width: fields.paperWidth, height: fields.paperHeight } = paper);
        }
    };
}
export const a3 = paperSize(A3);
export const a4 = paperSize(A4);
export const a5 = paperSize(A5);
export const a6 = paperSize(A6);
export const legal = paperSize(LEGAL);
export const letter = paperSize(LETTER);
export const tabloid = paperSize(TABLOID);
export function marginSizes(margins) {
    if (!margins)
        return noop;
    return (fields) => {
        if (Array.isArray(margins)) {
            ;
            [
                fields.marginTop,
                fields.marginRight,
                fields.marginBottom,
                fields.marginLeft,
            ] = margins;
        }
        else {
            ;
            ({
                top: fields.marginTop,
                right: fields.marginRight,
                bottom: fields.marginBottom,
                left: fields.marginLeft,
            } = margins);
        }
    };
}
export const noMargins = marginSizes(NO_MARGINS);
export const normalMargins = marginSizes(NORMAL_MARGINS);
export const largeMargins = marginSizes(LARGE_MARGINS);
