import { isString, isURL } from './_source-checkers';
import pipe from './_pipe';
import fields from './_fields';
import path from './_path';
import type from './_type';
function url(request) {
    let remoteURL;
    if (isString(request.source))
        remoteURL = request.source;
    else if (isURL(request.source))
        remoteURL = request.source.toString();
    else {
        throw new Error('Invalid source, should be url string or instance of URL');
    }
    return pipe(fields({
        remoteURL,
        marginTop: 0,
        marginBottom: 0,
        marginLeft: 0,
        marginRight: 0,
    }), path('/url'), type(0))({
        ...request,
        source: undefined,
    });
}
export default url;
